/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/
#ifndef _MARCDATASOURCE_H
#define _MARCDATASOURCE_H

#include <fstream>
#include <iomanip>
#include <iostream>
#include <string>
#include "marcrecord.h"
#include "marcutil.h"
#include "marceventobject.h"


using namespace std;


class MARCDataSource  {
public:
    MARCDataSource();
    ~MARCDataSource();

    bool LoadFromFile(char * szFileName); 
//	bool LoadFromBuffer(char * buffer, int iLen);
//	bool AttachToBuffer(const char * buffer, int iLen);
	//bool LoadZSearch(char * zURL, char * ccl);
	//bool LoadFTP(char * url);
	//bool LoadHTTP(char * url); 

	template<class TRecType>
    bool Read(TRecType & mr)
	{
	if(lOffset > (lBufLength - 1))
		return false;

	if(mr.Parse(buf + lOffset, lBufLength - lOffset))
	{
		lOffset += mr.GetRecordLength();
		return true;
	}
	return false;
	}

    void Reset() { lOffset = 0; }
    void Clear();

	const char * GetBuffer() { return (const char *) buf; } 

private: 

	unsigned char * buf;
	long lBufLength;
	long lOffset;   
};


MARCDataSource::MARCDataSource()
{
	buf = 0;
	lBufLength = 0;
	lOffset = 0;  
}

MARCDataSource::~MARCDataSource()
{
	Clear();	
}

void MARCDataSource::Clear()
{
	if(buf) delete [] buf;
	buf = 0;
	lBufLength = 0;
	lOffset = 0;  
}


bool MARCDataSource::LoadFromFile(char * szFileName)
{
	fstream file;
	file.open(szFileName, ios::in);

	if(!file) return false;

	file.seekg(0, ios::end);
	lBufLength = file.tellg();
	file.seekg(0);
	buf = new unsigned char [lBufLength];
	file.read((char *)buf, lBufLength);
	file.close();

	return true;
}





#endif