/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCFIELD_H
#define _MARCFIELD_H


#include <string>
#include "marcdir.h"
#include "marctag.h"


using namespace std;

class MARCField
{
public:
	MARCField();
	virtual ~MARCField();
	MARCField(const MARCField & mf);

	virtual bool Parse(const MARCTag & tag, unsigned char * szBuf, int iLen) = 0;

	virtual void MoveFirst() = 0;
	virtual void MoveNext() = 0;
	virtual bool IsEnd() = 0;

	virtual char SubFieldCode() = 0;

	virtual string SubFieldString() = 0;
//  virtual wstring SubFieldWString() = 0;

	virtual string GetString(char * szFormat = NULL, bool bIndicator = false) = 0;
	virtual string GetSubField(char c) = 0;

//	virtual string GetWString(char * szFormat = NULL, bool bIndicator = false) = 0;
//	virtual string GetWSubField(char c) = 0;

	virtual char GetIndicator(int i) = 0;
//	virtual bool SetIndicator(int i, char c);

	MARCTag & Tag();



	bool IsData();
	bool IsControl();


protected:
	void RemoveSubFieldDelimiters(unsigned char * buf, int iLen);

	MARCTag mTag;

};

#endif