/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCLEADER_H
#define _MARCLEADER_H

#include <string>
#include "marcutil.h"

using namespace std;


enum marcEncoding { charEncoding_MARC8, charEncoding_Unicode, charEncoding_Unknown };

class MARCLeader
{
public:
	virtual bool Parse(unsigned char * szBuf, int iBufLength) = 0;
	virtual int GetRecLength() = 0;
	virtual int GetBaseAddressOfData() = 0;
	virtual marcEncoding GetCharEncoding() = 0;


	int recordLength;
    char recordStatus;
    char recordType;
    char charCodingScheme;
    char indicatorCount;
    char subfieldCodeLength;
    int baseAddressOfData;
};


#endif