/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCRECORD_H
#define _MARCRECORD_H


#include "marcfield.h"
#include "marcleader.h"
#include "marctag.h"
#include "marcdef.h"



using namespace std;


template<class TLeader, class TDir>
class MARCRecord 
{
public:
	virtual ~MARCRecord() {  }
	
	virtual bool Parse(unsigned char * szBuf, int iBufLength) = 0;
	virtual void MoveFirst() = 0;
	virtual void MoveNext() = 0;
	virtual bool IsEnd() = 0;
	virtual bool FindFirst(char * szTag) = 0;
	virtual bool FindNext(char * szTag) = 0;
	virtual MARCField & Field() = 0;
	virtual MARCTag Tag() = 0;
	virtual string GetTitleString(char * szTag = "245") = 0;

	int GetRecordLength() { return leader.GetRecLength(); }
	bool IsValid() { return bValid; }

	TLeader leader;
	bool bValid;
};



#endif