
#include "marctag.h"


MARCTag::MARCTag()
{
	buf[0] = 0; 
}


MARCTag::~MARCTag()
{

}

MARCTag::MARCTag(const MARCTag & mt)
{
	memcpy(buf, mt.buf, 4);
}

void MARCTag::Parse(unsigned char * szBuf, int iLen)
{
	if(iLen >= 3)
	{
	memcpy(buf, szBuf, 3);
	buf[3] = 0;
	}
	else
	{
	buf[0] = 0;
	}
}

const char * MARCTag::c_str()
{ 
	buf[3] = 0; 
	return buf; 
} 

void MARCTag::Clear()
{
	buf[0] = 0;
}

bool MARCTag::operator<(const MARCTag & mt) const
{
	return (strcmp(buf, mt.buf) < 0); 
}


bool MARCTag::operator==(const MARCTag & mt) const
{
	return (strcmp(buf, mt.buf) == 0);
}

bool MARCTag::IsControl()
{
	return ((buf[0] == '0') && (buf[1] == '0')) ? true : false;
}

bool MARCTag::IsData()
{
	return ((buf[0] == '0') || (buf[1] == '0')) ? false : true;
}

MARCTag & MARCTag::operator=(const MARCTag & mt)
{
	if(&mt != this)
	{
	memcpy(buf, mt.buf, 4);
	}
	return *this;
}

MARCTag & MARCTag::operator=(const string & str)
{
	if(str.length() <= 3)
	{
		memcpy(buf, str.c_str(), 3);
		buf[3] = 0;
	}
	else
	{
		buf[0] = 0;
	}
	return *this;
}


MARCTag & MARCTag::operator=(const char * szStr)
{
	if(strlen(szStr) <= 3)
	{
		memcpy(buf, szStr, 3);
		buf[3] = 0;
	}
	else
	{
		buf[0] = 0;
	}
	return *this;
}