/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/

#ifndef _MARCTOHTML_H
#define _MARCTOHTML_H

#include <string>
#include <iostream>
#include "marcrecord.h"

using namespace std;

enum marcHTML { basic, full };

template<class TRecType>
bool MARC_To_HTML(string & output, TRecType & rec, marcHTML format = basic)
{
	string title, creator, subject, publisher;
	rec.MoveFirst();

	while(!rec.IsEnd())
	{
	string tag;
	tag = rec.Tag().c_str();

	if("245" == tag)
	{
	title = rec.Field().GetString();
	}
	else if("100" == tag)
	{
	creator = rec.Field().GetString();
	}
	else if("260" == tag)
	{
	publisher = rec.Field().GetString();
	}
	else if("600" == tag)
	{
	subject = rec.Field().GetString();
	}
	rec.MoveNext();
	}

	output = "<table><tr><td>" + title + "</td></tr><tr><td>" + subject + publisher + "</tr></table>";

	return true;
}








#endif