/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCTOXML_H
#define _MARCTOXML_H


#include <string>
#include <iostream>
#include "marcrecord.h"

using namespace std;


enum marcSchema { MARCPL };

template<class TRecType>
bool MARC_To_XML(string & output, TRecType & rec, marcSchema schema = MARCPL)
{
	rec.MoveFirst();

	output += "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>";
	output += "\n<marc><record>";

	while(!rec.IsEnd())
	{
	if(rec.Field().IsControl())
	{
	output += "<field type=\"";
	output += rec.Field().Tag().c_str();
	output += "\">";
	output += rec.Field().GetString();
	}
	else
	{
	output += "<field type=\"";
	output += rec.Field().Tag().c_str();
	output += "\" i1=\"";
	output += rec.Field().GetIndicator(0);
	output += "\" i2=\"";
	output += rec.Field().GetIndicator(1);
	output += "\">";
	output += rec.Field().GetString();
	}
	output += "</field>\n";
	rec.MoveNext();
	}
	output += "</record></marc>";
	return true;
}





#endif