/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/
#ifndef _STATIC_MARCFIELD_H
#define _STATIC_MARCFIELD_H


#include <string>
#include "marcfield.h"
#include "marcdef.h"


using namespace std;



class Static_MARCField : public MARCField
{
public:
	Static_MARCField();
	~Static_MARCField();
	Static_MARCField(const Static_MARCField & f);

	Static_MARCField & operator=(const Static_MARCField & f);


	bool Parse(const MARCTag & tag, unsigned char * szBuf, int iLen);

	void MoveFirst();
	void MoveNext();
	bool IsEnd();

	char SubFieldCode();
	string SubFieldString();

	char GetIndicator(int i);


	string GetString(char * szFormat, bool bIndicator);
	string GetSubField(char c);



private:

	unsigned char * buf;
	int iLength;

	int iOffset;




};




#endif