
/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

	MARC to XML



  ***************************************************/


#include <iostream>
#include <vector>
#include "../include/mtl.h"
#include <conio.h>
#include <algorithm>



using namespace std;

void PrintHelp(void);


int main(int argc, char* argv[])
{
	if(argc != 3)
		PrintHelp();
	else
	{
	MARCDataSource reader;

	if(!reader.LoadFromFile(argv[1]))
	{
	cout << "ERROR: Unable to Open file";
		return 0;
	}

	MARC21_StaticRecord rec;
	
	fstream file;
	file.open(argv[2], ios::out);

	if(!file) return 0;

	while(reader.Read(rec))
	{
		string str;
		MARC_To_XML(str, rec);
		file.write(str.c_str(), str.length());
	}

	file.close();
	}

	return 0;
}


void PrintHelp(void)
{
	cout << "\nMARC to XML Version 0.3\nCopyright Mark Basedow 2002.";
	cout << "\nCreated using MARC Template Library\nmark_basedow@hotmail.com\n\n";
	cout << "Usage: marctoxml source.mrc dest.xml\n";
}