/****************************************************
	MARC Template Library 

  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: mark_basedow@hotmail.com

	Please read licence.txt that is
	distributed with this file.

	The MARCEventObject is strongly influence by James
	an event based api for MARC records by Bas Peters 
	http://www.bpeters.com/


	I have made a number of simplifications. I see no
	need to be notified of the end of fields as MARC 
	fields are not nested as is the data in XML (James 
	was influenced by SAX). I also prefer to treat each
	record individually rather than as just a stream
	as James does. This will make it easier to use
	with the Z39.50 protocol where is MARC record is
	embeded in a BER APDU as external data.

	Test Program Three 

	Demonstrates the use of the MARCEventObject


	Note: you need to cast the MARCEventObject derived
	class to a MARCRecord class for the MARCReader
	Read method. I,ll tidy this up later.

  ***************************************************/

#include <iostream>
#include <vector>
#include "../include/mtl.h"
#include <conio.h>

using namespace std;

class MARC21_EventRecord : public MARCEventRecord<MARC21_Leader, MARC21_Dir> 
{
public:

	void startRecord(const MARC21_Leader & leader)
	{
		cout << "\nstartRecord";

	}

    void endRecord()
	{

		cout << "\nendRecord";
	}

    void controlField(MARCTag & tag, unsigned char * data, int iLen) 
	{
		cout << "\ncontrolField: " << tag.c_str();

	}

    void dataField(MARCTag & tag, char ind1, char ind2)
	{

	cout << "\ndataField: " << tag.c_str();

	}


    void subfield(MARCTag & tag, char identifier, unsigned char * data, int iLen)
	{



	}


};


int main(int argc, char* argv[])
{
	MARCDataSource reader;

	if(!reader.LoadFromFile("test.mrc"))
	{
	cout << "ERROR: Unable to Open file";
	getch();
		return 0;
	}

	MARC21_EventRecord rec;

	while(reader.Read(rec))
	{

	}

	getch();

	return 0;
}

