// winmtlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "winmtl.h"
#include "winmtlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinmtlDlg dialog

CWinmtlDlg::CWinmtlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWinmtlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWinmtlDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


}

void CWinmtlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWinmtlDlg)
	DDX_Control(pDX, IDC_COMBOCONVTYPE, m_ConvType);
	DDX_Control(pDX, IDC_EDITOUTPUT, m_Output);
	DDX_Control(pDX, IDC_EDITINPUT, m_Input);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWinmtlDlg, CDialog)
	//{{AFX_MSG_MAP(CWinmtlDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTONOPEN, OnButtonopen)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTONCONVERT, OnButtonconvert)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinmtlDlg message handlers

BOOL CWinmtlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_ConvType.AddString("MARC21 to XML");
	m_ConvType.AddString("MARC21 to Dublin Core(Unqualified)");
	m_ConvType.AddString("MARC21 to Dublin Core(Qualified)");
	m_ConvType.SetCurSel(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWinmtlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWinmtlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWinmtlDlg::OnButtonopen() 
{
	char szFilter[] = "MARC Files (*.mrc)|*.mrc||";

	CFileDialog fdlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);

	if(fdlg.DoModal() == IDOK)
	{
	m_Input.SetWindowText("");
	m_Output.SetWindowText("");
	mds.Clear();
	mds.LoadFromFile((char *)(LPCSTR)fdlg.GetFileName());	
	m_Input.SetWindowText(mds.GetBuffer());
	}
}

void CWinmtlDlg::OnDestroy() 
{
	CDialog::OnDestroy();	
}

void CWinmtlDlg::OnButtonconvert() 
{
	MARC21_StaticRecord rec;
	CString output;

	CString s;
	m_ConvType.GetWindowText(s);

	mds.Reset();

	if(s == "MARC21 to XML")
	{
	while(mds.Read(rec))
	{
		string str;
		MARC_To_XML(str, rec);
		output =+ str.c_str();
	}
	}
	else if(s == "MARC21 to Dublin Core(Unqualified)")
	{
	while(mds.Read(rec))
	{
		DublinCore dc;

		MARC_To_DublinCore(dc, rec, MARC21_To_UnqualifiedDC);
		string sxml;
		dc.GetXML(sxml);
		output =+ sxml.c_str();

	}
	}
	else if(s == "MARC21 to Dublin Core(Qualified)")
	{
	while(mds.Read(rec))
	{
		DublinCore dc;

		MARC_To_DublinCore(dc, rec, MARC21_To_QualifiedDC);
		string sxml;
		dc.GetXML(sxml);
		output =+ sxml.c_str();
	}
	}

	output.Replace("\n", "\r\n");
	m_Output.SetWindowText(output);

}
